```@meta
CurrentModule = GeometricMachineLearning
```

# Geometric Machine Learning

GeometricMachineLearning.jl implements various scientific machine learning models that aim at learning dynamical systems with geometric structure, such as Hamiltonian (symplectic) or Lagrangian (variational) systems.

## Installation

*GeometricMachineLearning.jl* and all of its dependencies can be installed via the Julia REPL by typing 
```julia
]add GeometricMachineLearning
```

## Architectures

```@contents
Pages = [
    "architectures/sympnet.md",
]
```

## Manifolds

```@contents
Pages = [
    "manifolds/grassmann_manifold.md",
    "manifolds/stiefel_manifold.md",
]
```
